///
pub struct Entry
{
   ///
   name: String,

   ///
   type_hint: String,

   ///
   path: String
}

///
pub struct Loader
{
   ///
   entries: Vec<Entry>
}



impl Entry
{
   ///
   pub fn new(entry_name: String, entry_type: String, entry_path: String)
      -> Entry
   {
      Entry
      {
         name: entry_name,
         type_hint: entry_type,
         path: entry_path
      }
   }

   ///
   pub fn get_name(&self) -> &str
   {
      self.name.as_str()
   }

   ///
   pub fn get_type(&self) -> &str
   {
      self.type_hint.as_str()
   }

   ///
   pub fn get_path(&self) -> &str
   {
      self.path.as_str()
   }
}

impl Loader
{
   ///
   pub fn new() -> Loader
   {
      Loader
      {
         entries: Vec::new()
      }
   }

   ///
   pub fn add_resource_entry(&mut self, name: String,
                             type_hint: String, path: String)
   {
      let entry: Entry;

      entry = Entry::new(name, type_hint, path);
      self.entries.push(entry);
   }

   ///
   pub fn get_resource_entries(&self) -> &Vec<Entry>
   {
      &self.entries
   }
}
